--- old/usr/src/uts/common/fs/zfs/unique.c	2015-11-02 01:49:40.490314472 +0100
+++ new/usr/src/uts/common/fs/zfs/unique.c	2015-11-02 01:49:40.501836115 +0100
@@ -99,6 +99,21 @@
 	return (un->un_value);
 }
 
+boolean_t
+unique_valid(uint64_t value)
+{
+	unique_t un_tofind;
+
+	un_tofind.un_value = value;
+
+	mutex_enter(&unique_mtx);
+	boolean_t rv = ((value & ~UNIQUE_MASK) == 0 &&
+	    avl_find(&unique_avl, &un_tofind, NULL) == NULL);
+	mutex_exit(&unique_mtx);
+
+	return (rv);
+}
+
 void
 unique_remove(uint64_t value)
 {
